%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                 Namira                                  %
%                              www.nn4e.com                               %  
%                              nn4e@aol.com                               %
%                              +989360703858                              %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

I=imread('pic2.jpg');
figure(1),imshow(I);
title('original image');
I1=rgb2gray(I);
figure(2),subplot(1,2,1),imshow(I1);title('gray image');
figure(2),subplot(1,2,2),imhist(I1);title('histogram');

I2=edge(I1,'roberts',0.18,'both');
figure(3),imshow(I2);title('roberts operator edge detection image');

se=[1;1;1];
I3=imerode(I2,se);
figure(4),imshow(I3);title('corrosion image');

se=strel('rectangle',[25,25]);
I4=imclose(I3,se);
figure(5),imshow(I4);title('smothing image');

I5=bwareaopen(I4,2000);
figure(6),imshow(I5);title('remove the small objects');


[y,x,z]=size(I5);
myI=double(I5);
tic
Blue_y=zeros(y,1); 
for i=1:y
    for j=1:x
        if(myI(i,j,1))
            Blue_y(i,1)=Blue_y(i,1)+1;
        end
    end
end
[temp MaxY]=max(Blue_y);
PY1=MaxY;
while((Blue_y(PY1,1)>=5)&&(PY1>1))
    PY1=PY1-1;
end
PY2=MaxY;
while((Blue_y(PY2,1)>=5)&&(PY2<y))
    PY2=PY2+1;
end
IY=I(PY1:PY2,:,:);
Blue_x=zeros(1,x);
for j=1:x
    for i=PY1:PY2
        if(myI(i,j,1)==1)
            Blue_x(1,j)=Blue_x(1,j)+1;
        end
    end
end
PX1=1;
while((Blue_x(1,PX1)<3)&&(PX1<x))
    PX1=PX1+1;
end
PX2=x;
while((Blue_x(1,PX2)<3)&&(PX2>PX1))
    PX2=PX2-1;
end
 PX1=PX1-1;
 PX2=PX2+1;
 dw=I(PY1:PY2-8,PX1:PX2,:);
 toc;
 t=toc;
 figure(7),subplot(1,2,1),imshow(IY),title('Line direction areas');
 figure(7),subplot(1,2,2),imshow(dw),title('positioning color images');